
---
apiVersion: v1
kind: Service
metadata:
  name: keycloak
spec:
  selector:
    app: keycloak
  ports:
    - port: 8080
  type: ClusterIP

---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: keycloak
  labels:
    app: keycloak
spec:
  replicas: 1
  selector:
    matchLabels:
      app: keycloak
  template:
    metadata:
      name: keycloak
      labels:
        app: keycloak
    spec:
      containers:
      - name: keycloak
        image: jboss/keycloak
        imagePullPolicy: IfNotPresent
        ports:
        - containerPort: 8080
          name: keycloakport
        env:
        - name: KEYCLOAK_USER
          value: "admin"
        - name: KEYCLOAK_PASSWORD
          value: "K8s@MMS2022?"
        - name: DB_VENDOR
          value: "h2"
        - name: KEYCLOAK_LOGLEVEL
          value: INFO
        - name: ROOT_LOGLEVEL
          value: INFO
        - name: PROXY_ADDRESS_FORWARDING
          value: "true"
        resources:
          limits:
            cpu: 500m
            memory: 1024Mi
        # readinessProbe:
        #   httpGet:
        #     path: /auth/realms/master
        #     port: 8080
        # startupProbe:
        #   httpGet:
        #     path: /auth/realms/master
        #     port: 8080
        #   failureThreshold: 30
        #   periodSeconds: 10

---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: redirect-to-https
spec:
  redirectScheme:
    scheme: https
    permanent: true
    port: "30443"

---
apiVersion: traefik.containo.us/v1alpha1
kind: IngressRoute
metadata:
  name: keycloak-http
  annotations:
    kubernetes.io/ingress.class: "traefik-crd"
spec:
  entryPoints:
  - web
  routes:
  - match: Host(`keycloak.cluster${CNR}.aemc.me`)
    kind: Rule
    middlewares:
    - name: "redirect-to-https"
    services:
    - name: keycloak
      kind: Service
      port: 8080

---
apiVersion: traefik.containo.us/v1alpha1
kind: IngressRoute
metadata:
  name: keycloak-https
  annotations:
    kubernetes.io/ingress.class: "traefik-crd"
spec:
  entryPoints:
  - websecure
  routes:
  - match: Host(`keycloak.cluster${CNR}.aemc.me`)
    kind: Rule
    services:
      - name: keycloak
        kind: Service
        port: 8080
  tls: {}

---
kind: ClusterRoleBinding
apiVersion: rbac.authorization.k8s.io/v1
metadata:
  name: oidc-admin-binding
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: cluster-admin
subjects:
  - kind: User
    name: oidcadmin
